VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Google Translator"
   ClientHeight    =   4695
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   11940
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   313
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   796
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdPlayOutput 
      Caption         =   "4"
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   12
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3600
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   450
      Width           =   375
   End
   Begin VB.Timer trPlay 
      Enabled         =   0   'False
      Left            =   4020
      Top             =   450
   End
   Begin VB.CommandButton cmdPlayInput 
      Caption         =   "4"
      BeginProperty Font 
         Name            =   "Webdings"
         Size            =   12
         Charset         =   2
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   3180
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   450
      Width           =   375
   End
   Begin VB.CommandButton cmdTranslate 
      Caption         =   "Translate"
      Height          =   375
      Left            =   30
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   450
      Width           =   3120
   End
   Begin VB.CommandButton cmdChange 
      Caption         =   "<>"
      Height          =   375
      Left            =   3180
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   30
      Width           =   600
   End
   Begin VB.ComboBox cbOutput 
      Height          =   375
      Left            =   3810
      Style           =   2  'Dropdown List
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   30
      Width           =   3120
   End
   Begin VB.ComboBox cbInput 
      Height          =   375
      Left            =   30
      Style           =   2  'Dropdown List
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   30
      Width           =   3120
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private hFont As Long
Private hWndTbInput As Long
Private hWndTbOutput As Long
Private sOldInputText As String
Private sOldOutputText As String
Private sMP3Input As String
Private sMP3Output As String
Private cPlayer As clsMP3Player

Private Sub Form_Load()

    Dim hLib As Long
    Dim lStyle As Long
    Dim lExStyle As Long
    Dim lProcAddress As Long
    Dim sLangArr() As String
    Dim lItem As Long
    Dim lCount As Long
    Dim tICCEx As udtINITCOMMONCONTROLSEX
    
    Me.ScaleMode = vbPixels
    
    With m_tSIZEPAR

        .xMin = 500 'min. FormWidth
        .yMin = 250 'min. FormHeight
        .xMax = Screen.Width 'max. FormWidth
        .yMax = Screen.Height 'max. FormHeight
    
    End With
    
    trPlay.Enabled = False
    trPlay.Interval = 100
    
    Set cPlayer = New clsMP3Player
    
    m_WinProc = SetWindowLong(Me.hwnd, GWL_WNDPROC, AddressOf WinProc)

    hLib = LoadLibrary(StrPtr("comctl32.dll"))

    If hLib <> 0 Then

        lProcAddress = GetProcAddress(hLib, "InitCommonControlsEx")

        If lProcAddress <> 0 Then

            With tICCEx

                .dwSize = Len(tICCEx)
                .dwICC = ICC_STANDARD_CLASSES

            End With

            Call InitCommonControlsEx(tICCEx)

            lStyle = ES_LEFT Or ES_MULTILINE Or ES_WANTRETURN Or WS_CHILD Or _
                WS_OVERLAPPED Or WS_VISIBLE Or WS_VSCROLL

            lExStyle = WS_EX_CLIENTEDGE Or WS_EX_LEFT Or WS_EX_LTRREADING Or _
                WS_EX_RIGHTSCROLLBAR

            hFont = CreateFont(-MulDiv(TBFontSize, GetDeviceCaps(Me.hDC, _
                LOGPIXELSY), 72), 0&, 0&, 0&, FW_NORMAL, 0&, 0&, 0&, 0&, _
                0&, 0&, 0&, 0&, StrPtr(TBFontName))

            hWndTbInput = CreateWindowEx(lExStyle, StrPtr(WC_EDITW), StrPtr( _
                "InputBox"), lStyle, 0&, 0&, 0&, 0&, Me.hwnd, 0&, _
                App.hInstance, ByVal 0&)

            If hWndTbInput <> 0& Then
            
                If hFont <> 0& Then

                    Call SendMessage(hWndTbInput, WM_SETFONT, hFont, ByVal API_TRUE)
                    
                Else
                
                    Call SendMessage(hWndTbInput, WM_SETFONT, GetStockObject( _
                        DEFAULT_GUI_FONT), ByVal API_TRUE)
                
                End If
                    
                Call SetTbText(hWndTbInput, vbNullString)

            End If
            
            hWndTbOutput = CreateWindowEx(lExStyle, StrPtr(WC_EDITW), StrPtr( _
                "OutputBox"), lStyle, 0&, 0&, 0&, 0&, Me.hwnd, 0&, _
                App.hInstance, ByVal 0&)
            
            If hWndTbOutput <> 0& Then

                If hFont <> 0& Then

                    Call SendMessage(hWndTbOutput, WM_SETFONT, hFont, ByVal API_TRUE)
                    
                Else
                
                    Call SendMessage(hWndTbOutput, WM_SETFONT, GetStockObject( _
                        DEFAULT_GUI_FONT), ByVal API_TRUE)
                
                End If

                Call SetTbText(hWndTbOutput, vbNullString)
                
            End If
            
            Call FreeLibrary(hLib)

        End If
        
    End If

    sLangArr = Split(sLanguage, ",")
    
    lCount = UBound(sLangArr)
    
    For lItem = 0 To lCount
    
        cbInput.AddItem Split(sLangArr(lItem), "/")(0)
        
        If lItem > 0 Then
        
            cbOutput.AddItem Split(sLangArr(lItem), "/")(0)
            
        End If
        
    Next
    
    cbInput.ListIndex = 0 ' Automatisch
    cbOutput.ListIndex = 15 ' Deutsch
    
    Call SetForegroundWindow(hWndTbInput)
    Call PutFocus(hWndTbInput)

End Sub

Private Sub Form_Resize()

    Dim lngWidth As Long

    If Me.WindowState <> vbMinimized Then

        lngWidth = Me.ScaleWidth \ 2

        cbInput.Move 2, 2
        cbOutput.Move Me.ScaleWidth - (cbOutput.Width + 2), 2
        cmdChange.Move lngWidth - (cmdChange.Width \ 2), 2
        cmdTranslate.Move 2, Me.ScaleHeight - (cmdTranslate.Height + 2)
        cmdPlayInput.Move lngWidth - (cmdPlayInput.Width + 2), Me.ScaleHeight - (cmdPlayInput.Height + 2)
        cmdPlayOutput.Move Me.ScaleWidth - (cmdPlayOutput.Width + 2), Me.ScaleHeight - (cmdPlayOutput.Height + 2)

        If hWndTbInput <> 0& Then

            If hWndTbOutput <> 0& Then

                Call MoveTb(hWndTbInput, 2, cbInput.Top + cbInput.Height + 2, _
                    lngWidth - 2, Me.ScaleHeight - 58)

                Call MoveTb(hWndTbOutput, lngWidth + 2, cbOutput.Top + _
                    cbOutput.Height + 2, lngWidth - 4, Me.ScaleHeight - 58)

            End If

        End If

    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Call SetWindowLong(Me.hwnd, GWL_WNDPROC, m_WinProc)
    
    trPlay.Enabled = False
    
    Set cPlayer = Nothing

    If hWndTbInput <> 0& Then Call DestroyWindow(hWndTbInput)
    If hWndTbOutput <> 0& Then Call DestroyWindow(hWndTbOutput)
    If hFont <> 0& Then Call DeleteObject(hFont)

End Sub

Private Sub cmdTranslate_Click()

    Call InternTranslate

End Sub

Private Sub cmdChange_Click()

    Dim strTxt As String
    Dim lngLangID As Long

    If cbInput.ListIndex <> 0 Then

        lngLangID = cbOutput.ListIndex
        strTxt = GetTbText(hWndTbInput)

        cbOutput.ListIndex = cbInput.ListIndex - 1
        cbInput.ListIndex = lngLangID + 1

        Call SetTbText(hWndTbInput, GetTbText(hWndTbOutput))
        Call SetTbText(hWndTbOutput, strTxt)

        strTxt = sOldInputText
        sOldInputText = sOldOutputText
        sOldOutputText = strTxt

        strTxt = sMP3Input
        sMP3Input = sMP3Output
        sMP3Output = strTxt

        Me.Caption = "Google Translator (erkannte Sprache: " & _
            Split(Split(sLanguage, ",")(cbInput.ListIndex), "/")(0) & ")"

    End If

End Sub

Private Sub cmdPlayInput_Click()
    
    Call InternPlay(False)

End Sub

Private Sub cmdPlayOutput_Click()

    Call InternPlay(True)

End Sub


Private Sub trPlay_Timer()

    cPlayer.TimerTick
    
    If cPlayer.IsStopped = True Then
    
        trPlay.Enabled = False
        cmdPlayOutput.Caption = "4"
        cmdPlayInput.Caption = "4"
        cmdPlayOutput.Enabled = True
        cmdPlayInput.Enabled = True
    
    End If

End Sub

Private Sub InternPlay(Optional ByVal PlayOutput As Boolean = False)

    Dim strText As String
    Dim sLang As String
    Dim sLangName As String

    If PlayOutput = True Then

        sLang = Split(Split(sLanguage, ",")(cbOutput.ListIndex + 1), "/")(1)
        sLangName = Split(Split(sLanguage, ",")(cbOutput.ListIndex + 1), "/")(0)

    Else

        sLang = Split(Split(sLanguage, ",")(cbInput.ListIndex), "/")(1)
        sLangName = Split(Split(sLanguage, ",")(cbInput.ListIndex + 1), "/")(0)

    End If
    
    If sLang = "auto" Then Exit Sub

    If PlayOutput = True Then

        strText = URLEncode(UnicodeToUTF8(GetTbText(hWndTbOutput)))

    Else

        strText = URLEncode(UnicodeToUTF8(GetTbText(hWndTbInput)))
    
    End If

    'Debug.Print strText

    'Exit Sub

    If PlayOutput = True Then

        If cmdPlayOutput.Caption = "4" Then

            If strText <> sOldOutputText Then

                sOldOutputText = strText

                If Len(strText) > 0& Then
                
                    cmdPlayOutput.Caption = "<"
                    cmdPlayInput.Enabled = False
                    Me.MousePointer = 11
                    DoEvents

                    sMP3Output = GetMp3(strText, sLang)

                    If Len(sMP3Output) > 0& Then

                        If cPlayer.LoadMp3Data(sMP3Output) = True Then

                            trPlay.Enabled = True

                            Me.MousePointer = 0
                            DoEvents
                            cPlayer.StartPlaying
                            
                        Else
                            
                            cmdPlayOutput.Caption = "4"
                            cmdPlayInput.Enabled = True
                            Me.MousePointer = 0
                            DoEvents
                        
                        End If

                    Else
                            
                        cmdPlayOutput.Caption = "4"
                        cmdPlayInput.Enabled = True
                        Me.MousePointer = 0
                        DoEvents
                        MsgBox "Die Sprachausgabe ist fr " & sLangName & " nicht verfgbar.", vbOKOnly Or vbInformation
                    
                    End If

                End If

            Else

                If Len(strText) > 0& Then

                    If Len(sMP3Output) > 0& Then

                        If cPlayer.LoadMp3Data(sMP3Output) = True Then

                            trPlay.Enabled = True

                            cPlayer.StartPlaying
                            cmdPlayOutput.Caption = "<"
                            cmdPlayInput.Enabled = False

                        Else
                            
                            cmdPlayOutput.Caption = "4"
                            cmdPlayInput.Enabled = True
                            Me.MousePointer = 0
                            DoEvents

                        End If

                    Else
                            
                        cmdPlayOutput.Caption = "4"
                        cmdPlayInput.Enabled = True
                        Me.MousePointer = 0
                        DoEvents
                        MsgBox "Die Sprachausgabe ist fr " & sLangName & " nicht verfgbar.", vbOKOnly Or vbInformation
                    
                    End If

                End If

            End If

        Else

            cPlayer.StopPlaying

        End If

    Else

        If cmdPlayInput.Caption = "4" Then

            If strText <> sOldInputText Then

                sOldInputText = strText

                If Len(strText) > 0& Then

                    cmdPlayInput.Caption = "<"
                    cmdPlayOutput.Enabled = False
                    Me.MousePointer = 11
                    DoEvents

                    sMP3Input = GetMp3(strText, sLang)

                    If Len(sMP3Input) > 0& Then

                        If cPlayer.LoadMp3Data(sMP3Input) = True Then

                            trPlay.Enabled = True

                            Me.MousePointer = 0
                            DoEvents
                            cPlayer.StartPlaying

                        Else
                            
                            cmdPlayInput.Caption = "4"
                            cmdPlayOutput.Enabled = True
                            Me.MousePointer = 0
                            DoEvents

                        End If

                    Else
                            
                        cmdPlayInput.Caption = "4"
                        cmdPlayOutput.Enabled = True
                        Me.MousePointer = 0
                        DoEvents
                        MsgBox "Die Sprachausgabe ist fr " & sLangName & " nicht verfgbar.", vbOKOnly Or vbInformation
                    
                    End If

                End If

            Else

                If Len(strText) > 0& Then

                    If Len(sMP3Input) > 0& Then

                        If cPlayer.LoadMp3Data(sMP3Input) = True Then

                            trPlay.Enabled = True

                            cPlayer.StartPlaying
                            cmdPlayInput.Caption = "<"
                            cmdPlayOutput.Enabled = False

                        Else
                            
                            cmdPlayInput.Caption = "4"
                            cmdPlayOutput.Enabled = True
                            Me.MousePointer = 0
                            DoEvents

                        End If

                    Else
                            
                        cmdPlayInput.Caption = "4"
                        cmdPlayOutput.Enabled = True
                        Me.MousePointer = 0
                        DoEvents
                        MsgBox "Die Sprachausgabe ist fr " & sLangName & " nicht verfgbar.", vbOKOnly Or vbInformation
                    
                    End If

                End If

            End If

        Else

            cPlayer.StopPlaying

        End If

    End If

End Sub

Private Sub InternTranslate()

    Dim lngLangID As Long
    Dim strLangInput As String
    Dim strLangOutput As String
    Dim strJSON As String
    Dim strTxt As String
    
    strLangInput = Split(Split(sLanguage, ",")(cbInput.ListIndex), "/")(1)
    strLangOutput = Split(Split(sLanguage, ",")(cbOutput.ListIndex + 1), "/")(1)
    
    strTxt = GetTbText(hWndTbInput)
    
    If Len(strTxt) > 0 Then
    
        strJSON = Tanslate(URLEncode(UnicodeToUTF8(strTxt)), _
            strLangInput, strLangOutput)
    
        Me.Caption = "Google Translator (erkannte Sprache: " & _
            IdentifyLanguage(strJSON, lngLangID) & ")"
    
        cbInput.ListIndex = lngLangID
    
        Call SetTbText(hWndTbOutput, UTF8ToUnicode( _
            DecodeUTF8(GetTranslation(strJSON))))
    
    End If
    
    Call SetForegroundWindow(hWndTbInput)
    Call PutFocus(hWndTbInput)

End Sub
