Attribute VB_Name = "modMain"
Option Explicit

' ---=== sonstige Const ===---
Public Const S_OK As Long = &H0&
Public Const API_TRUE As Long = &H1&
Public Const API_FALSE As Long = &H0&
Public Const LOGPIXELSY As Long = 90
Public Const CP_UTF8 As Long = 65001
Public Const INTERNET_OPEN_TYPE_DIRECT As Long = &H1&
Public Const INTERNET_OPEN_TYPE_PROXY As Long = &H3&
Public Const INTERNET_FLAG_RELOAD As Long = &H80000000
Public Const TBFontSize As Long = 12
Public Const TBFontName As String = "Segoe UI"

' ---=== WNDPROC ===---
Public Const GWL_WNDPROC As Long = -4

' ---=== StockObject ===---
Public Const DEFAULT_GUI_FONT As Long = 17

' ---=== CreateFont ===---
Public Const FW_NORMAL As Long = 400

' ---=== CommonControlsEx ===---
Public Const ICC_STANDARD_CLASSES As Long = &H4000

' ---=== Controls ===---
Public Const WC_EDITW As String = "Edit"

' ---=== Window Styles ===---
Public Const WS_CHILD As Long = &H40000000
Public Const WS_OVERLAPPED As Long = &H0&
Public Const WS_VISIBLE As Long = &H10000000
Public Const WS_VSCROLL As Long = &H200000

' ---=== Window ExStyles ===---
Public Const WS_EX_CLIENTEDGE As Long = &H200&
Public Const WS_EX_LEFT As Long = &H0&
Public Const WS_EX_LTRREADING As Long = &H0&
Public Const WS_EX_RIGHTSCROLLBAR As Long = &H0&

' ---=== Window Message ===---
Public Const WM_SETFONT As Long = &H30
Public Const WM_SETTEXT As Long = &HC
Public Const WM_GETTEXT As Long = &HD
Public Const WM_GETTEXTLENGTH As Long = &HE
Public Const WM_CTLCOLOREDIT As Long = &H133
Public Const WM_GETMINMAXINFO = &H24

' ---=== Edit Styles ===---
Public Const ES_LEFT As Long = &H0&
Public Const ES_MULTILINE As Long = &H4&
Public Const ES_WANTRETURN As Long = &H1000&

' ---=== Language Const  ===---
Public Const sLanguage As String = "Automatisch/auto,Afrikaans/af,Albanisch/sq,Amharisch/am,Arabisch/ar,Armenisch/hy," & _
                                   "Aserbaidschanisch/az,Baskisch/eu,Bengalisch/bn,Bosnisch/bs,Bulgarisch/bg,Cebuano/ceb," & _
                                   "Chinesisch/zh,Chinesisch (traditionell)/zh-TW,Chinesisch (vereinfacht)/zh-CN,Dnisch/da," & _
                                   "Deutsch/de,Englisch/en,Esperanto/eo,Estnisch/et,Finnisch/fi,Franzsisch/fr,Friesisch/fy," & _
                                   "Galicisch/gl,Georgisch/ka,Griechisch/el,Gujarati/gu,Haussa/ha,Hawaiianisch/haw,Hebrisch/he," & _
                                   "Hindi/hi,Hmong/hmn,Igbo/ig,Indonesisch/id,Irisch/ga,Islndisch/is,Italienisch/it,Japanisch/ja," & _
                                   "Javanisch/jv,Jiddisch/yi,Kannada/kn,Kasachisch/kk,Katalanisch/ca,Khmer/km,Kirgisisch/ky," & _
                                   "Koreanisch/ko,Korsisch/co,Kreolisch (Haiti)/ht,Kroatisch/hr,Kurdisch/ku,Lao/lo,Latein/la," & _
                                   "Lettisch/lv,Litauisch/lt,Luxemburgisch/lb,Madagassisch/mg,Malaiisch/ms,Malayalam/ml,Maltesisch/mt," & _
                                   "Maori/mi,Marathi/mr,Mazedonisch/mk,Mongolisch/mn,Myanmar (Birmanisch)/my,Nepalesisch/ne," & _
                                   "Niederlndisch/nl,Norwegisch/no,Nyanja (Chichewa)/ny,Pandschabi/pa,Paschtunisch/ps,Persisch/fa," & _
                                   "Polnisch/pl,Portugiesisch (Portugal Brasilien)/pt,Rumnisch/ro,Russisch/ru,Samoanisch/sm," & _
                                   "Schottisches Glisch/gd,Schwedisch/sv,Serbisch/sr,Sesotho/st,Shona/sn,Sindhi/sd,Singhalesisch/si," & _
                                   "Slowakisch/sk,Slowenisch/sl,Somali/so,Spanisch/es,Sundanesisch/su,Swahili/sw,Tadschikisch/tg," & _
                                   "Tagalog (Philippinisch)/tl,Tamilisch/ta,Telugu/te,Thai/th,Tschechisch/cs,Trkisch/tr,Ukrainisch/uk," & _
                                   "Ungarisch/hu,Urdu/ur,Usbekisch/uz,Vietnamesisch/vi,Walisisch/cy,Weirussisch/be,Xhosa/xh,Yoruba/yo,Zulu/zu"

' ---=== Types  ===---
Public Type udtINITCOMMONCONTROLSEX
    dwSize As Long
    dwICC As Long
End Type

Public Type SIZEPAR
    xMin As Long
    xMax As Long
    yMin As Long
    yMax As Long
End Type

Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

' ---=== COMCTL32.DLL Deklarationen ===---
Public Declare Function InitCommonControlsEx Lib "comctl32.dll" ( _
                        ByRef lpICCEX As udtINITCOMMONCONTROLSEX) As Long

' ---=== GDI32.DLL Deklarationen ===---
Public Declare Function CreateFont Lib "gdi32.dll" _
                        Alias "CreateFontW" ( _
                        ByVal lHeight As Long, _
                        ByVal lWidth As Long, _
                        ByVal lEscapement As Long, _
                        ByVal lOrientation As Long, _
                        ByVal lBold As Long, _
                        ByVal lItalic As Long, _
                        ByVal lUnderline As Long, _
                        ByVal lStrikethrough As Long, _
                        ByVal lCharset As Long, _
                        ByVal lOutputPrecision As Long, _
                        ByVal lClipPrecision As Long, _
                        ByVal lQuality As Long, _
                        ByVal lPitchAndFamily As Long, _
                        ByVal lFontName As Long) As Long

Public Declare Function DeleteObject Lib "gdi32.dll" ( _
                        ByVal hObject As Long) As Long

Public Declare Function GetDeviceCaps Lib "gdi32.dll" ( _
                        ByVal hDC As Long, _
                        ByVal nIndex As Long) As Long

Public Declare Function GetStockObject Lib "gdi32.dll" ( _
                        ByVal nIndex As Long) As Long

' ---=== KERNEL32.DLL Deklarationen ===---
Public Declare Sub RtlMoveMemory Lib "kernel32.dll" ( _
                   ByRef Destination As Any, _
                   ByRef Source As Any, _
                   ByVal Length As Long)

Public Declare Function FreeLibrary Lib "kernel32.dll" ( _
                        ByVal hLibModule As Long) As Long

Public Declare Function GetProcAddress Lib "kernel32.dll" ( _
                        ByVal hModule As Long, _
                        ByVal lpProcName As String) As Long

Public Declare Function LoadLibrary Lib "kernel32.dll" _
                        Alias "LoadLibraryW" ( _
                        ByVal lpLibFileName As Long) As Long

Public Declare Function MulDiv Lib "kernel32.dll" ( _
                        ByVal lNumber As Long, _
                        ByVal lNumerator As Long, _
                        ByVal lDenominator As Long) As Long

Public Declare Function WideCharToMultiByte Lib "kernel32" ( _
                        ByVal CodePage As Long, _
                        ByVal dwFlags As Long, _
                        ByVal lpWideCharStr As Long, _
                        ByVal cchWideChar As Long, _
                        ByRef lpMultiByteStr As Any, _
                        ByVal cchMultiByte As Long, _
                        ByVal lpDefaultChar As String, _
                        ByVal lpUsedDefaultChar As Long) As Long

Public Declare Function MultiByteToWideChar Lib "kernel32" ( _
                        ByVal CodePage As Long, _
                        ByVal dwFlags As Long, _
                        ByRef lpMultiByteStr As Any, _
                        ByVal cchMultiByte As Long, _
                        ByVal lpWideCharStr As Long, _
                        ByVal cchWideChar As Long) As Long
                         
' ---=== USER32.DLL Deklarationen ===---
Public Declare Function CreateWindowEx Lib "user32.dll" _
                        Alias "CreateWindowExW" ( _
                        ByVal dwExStyle As Long, _
                        ByVal lpClassName As Long, _
                        ByVal lpWindowName As Long, _
                        ByVal dwStyle As Long, _
                        ByVal x As Long, _
                        ByVal y As Long, _
                        ByVal nWidth As Long, _
                        ByVal nHeight As Long, _
                        ByVal hWndParent As Long, _
                        ByVal hMenu As Long, _
                        ByVal hInstance As Long, _
                        ByRef lpParam As Any) As Long

Public Declare Function DestroyWindow Lib "user32.dll" ( _
                        ByVal hwnd As Long) As Long

Public Declare Function MoveWindow Lib "user32.dll" ( _
                        ByVal hwnd As Long, _
                        ByVal x As Long, _
                        ByVal y As Long, _
                        ByVal nWidth As Long, _
                        ByVal nHeight As Long, _
                        ByVal bRepaint As Long) As Long

Public Declare Function SetForegroundWindow Lib "user32.dll" ( _
                        ByVal hwnd As Long) As Long

Public Declare Function CallWindowProc Lib "user32.dll" _
                        Alias "CallWindowProcW" ( _
                        ByVal lpPrevWndFunc As Long, _
                        ByVal hwnd As Long, _
                        ByVal msg As Long, _
                        ByVal wParam As Long, _
                        ByVal lParam As Long) As Long

Public Declare Function DefWindowProc Lib "user32.dll" _
                        Alias "DefWindowProcW" ( _
                        ByVal hwnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Long, _
                        ByVal lParam As Long) As Long

Public Declare Function SetWindowLong Lib "user32.dll" _
                        Alias "SetWindowLongW" ( _
                        ByVal hwnd As Long, _
                        ByVal nIndex As Long, _
                        ByVal dwNewLong As Long) As Long

Public Declare Function SendMessage Lib "user32.dll" _
                        Alias "SendMessageW" ( _
                        ByVal hwnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Long, _
                        ByRef lParam As Any) As Long

Public Declare Function GetDC Lib "user32.dll" ( _
                        ByVal hwnd As Long) As Long

Public Declare Function Focus Lib "user32.dll" _
                        Alias "SetFocus" ( _
                        ByVal hwnd As Long) As Long

' ---=== WININET.DLL Deklarationen ===---
Public Declare Function InternetOpen Lib "wininet.dll" _
                        Alias "InternetOpenW" ( _
                        ByVal sAgent As Long, _
                        ByVal lAccessType As Long, _
                        ByVal sProxyName As Long, _
                        ByVal sProxyBypass As Long, _
                        ByVal lFlags As Long) As Long

Public Declare Function InternetOpenUrl Lib "wininet.dll" _
                        Alias "InternetOpenUrlW" ( _
                        ByVal hInternetSession As Long, _
                        ByVal lpszUrl As Long, _
                        ByVal lpszHeaders As Long, _
                        ByVal dwHeadersLength As Long, _
                        ByVal dwFlags As Long, _
                        ByVal dwContext As Long) As Long

Public Declare Function InternetReadFile Lib "wininet.dll" ( _
                        ByVal hFile As Long, _
                        ByVal sBuffer As String, _
                        ByVal lNumBytesToRead As Long, _
                        ByRef lNumberOfBytesRead As Long) As Integer

Public Declare Function InternetCloseHandle Lib "wininet.dll" ( _
                        ByVal hInet As Long) As Integer

' ---=== Variable ===---
Public m_WinProc As Long
Public m_tSIZEPAR As SIZEPAR

Public Function Tanslate(ByVal sText As String, ByVal sSrcLang As String, ByVal _
    sDestLang As String) As String
    
    Tanslate = GetData("https://translate.googleapis.com/translate_a/single?client=gtx" & _
        "&ie=UTF-8&oe=UTF-8&sl=" & sSrcLang & "&tl=" & sDestLang & "&dt=t&q=" & sText)
        
End Function

Public Function GetMp3(ByVal sText As String, ByVal sLang As String) As String
    
    Dim lngIdx As Long
    Dim lngTotal As Long
    Dim sWordArr() As String
    Dim strTmp As String
    Dim strMp3 As String
    Dim strArr() As String
    Dim lArrItem As Long
    Dim lWordItem As Long
    Dim lWordCount As Long

    If Len(sText) > 200 Then
        
        lArrItem = 0
        ReDim strArr(lArrItem)
    
        sWordArr = Split(sText, "%20")
        
        lWordCount = UBound(sWordArr)
        
        For lWordItem = 0 To lWordCount
        
            strTmp = sWordArr(lWordItem)
        
            If Len(strArr(lArrItem)) + Len(strTmp) + Len("%20") >= 200 Then
            
                lArrItem = lArrItem + 1
                ReDim Preserve strArr(lArrItem)
            
            End If
        
            strArr(lArrItem) = strArr(lArrItem) & strTmp & "%20"
        
        Next
    
        lngTotal = UBound(strArr)
    
        For lngIdx = 0 To lngTotal
    
            strTmp = GetData("https://translate.googleapis.com/translate_tts?client=gtx" & _
                "&ie=UTF-8&ttsspeed=1&total=" & CStr(lngTotal + 1) & "&idx=" & CStr(lngIdx) & _
                "&textlen=" & CStr(Len(strArr(lngIdx))) & "&tl=" & sLang & "&q=" & strArr(lngIdx))
        
            strMp3 = strMp3 & strTmp
    
        Next
    
    Else
    
        strMp3 = GetData("https://translate.googleapis.com/translate_tts?client=gtx" & _
            "&ie=UTF-8&ttsspeed=1&total=1&idx=0&textlen=" & CStr(Len(sText)) & _
            "&tl=" & sLang & "&q=" & sText)
        
    End If
    
    GetMp3 = strMp3
        
End Function

Public Function GetTranslation(ByVal sJSON As String) As String

    Dim strRet As String
    Dim strTmp As String
    Dim strArr() As String
    Dim lItem As Long
    Dim lCount As Long
    Dim lStart As Long
    Dim lEnde As Long

    If sJSON <> vbNullString Then

        strArr = Split(sJSON, vbLf)

        lCount = UBound(strArr)

        For lItem = 0 To lCount

            strTmp = strArr(lItem)

            If UBound(Split(strTmp, ",")) > 2 Then

                lStart = InStr(1, strTmp, "[" & ChrW$(34))

                If lStart > 0& Then

                    lStart = lStart + 2

                    lEnde = InStr(lStart, strTmp, ChrW$(34) & ",")

                    If lEnde > 0& Then

                        strRet = strRet & Mid$(strTmp, lStart, lEnde - lStart)

                    End If

                End If

            End If

        Next

    End If

    GetTranslation = strRet
    
End Function

Public Function IdentifyLanguage(ByVal sJSON As String, ByRef lLangID As Long) As String

    Dim lngItem As Long
    Dim lngCount As Long
    Dim strTmp As String
    Dim strRet As String
    Dim lStart As Long
    Dim lEnde As Long
    Dim sShort As String
    Dim strArr() As String

    If sJSON <> vbNullString Then

        strTmp = Replace$(sJSON, vbLf, vbNullString)

        lStart = InStr(1, strTmp, "]],null," & ChrW$(34))

        If lStart > 0& Then

            lStart = lStart + Len("]],null," & ChrW$(34))

            lEnde = InStr(lStart, strTmp, ChrW$(34))

            If lEnde > 0& Then

                sShort = Mid$(strTmp, lStart, lEnde - lStart)

                strArr = Split(sLanguage, ",")

                lngCount = UBound(strArr)

                For lngItem = 1 To lngCount

                    If UCase$(Split(strArr(lngItem), "/")(1)) = UCase$(sShort) Then

                        strRet = Split(strArr(lngItem), "/")(0)

                        Exit For

                    End If

                Next

            End If

        End If

    End If

    lLangID = lngItem
    IdentifyLanguage = strRet

End Function

Public Function GetData(ByVal sURL As String) As String

    Dim hOpen As Long
    Dim hFile As Long
    Dim strBuffer As String
    Dim strRet As String
    Dim lngRet As Long
    
    strBuffer = Space$(1000)

    hOpen = InternetOpen(StrPtr("VBC-Google-Translate"), _
        INTERNET_OPEN_TYPE_DIRECT, 0&, 0&, 0&)
    
    If hOpen <> 0& Then
    
        hFile = InternetOpenUrl(hOpen, StrPtr(sURL), 0&, 0&, _
            INTERNET_FLAG_RELOAD, 0&)

        If hFile <> 0& Then
    
            Do

                If InternetReadFile(hFile, strBuffer, Len(strBuffer), _
                    lngRet) = API_TRUE Then
                    
                    strRet = strRet & Left$(strBuffer, lngRet)
                    
                    If Len(strRet) = 0 Then Exit Do
                
                Else
                    
                    Exit Do
                
                End If

                If lngRet = 0& Then Exit Do

            Loop

            Call InternetCloseHandle(hFile)
    
        End If
    
        Call InternetCloseHandle(hOpen)
    
    End If
    
    GetData = strRet
    
End Function

Public Function UTF8ToUnicode(ByVal sUTF8 As String) As String

    Dim UTF8Size        As Long
    Dim BufferSize      As Long
    Dim BufferUNI       As String
    Dim LenUNI          As Long
    Dim bUTF8()         As Byte
    
    If LenB(sUTF8) = 0 Then Exit Function
    
    bUTF8 = StrConv(sUTF8, vbFromUnicode)
    UTF8Size = UBound(bUTF8) + 1
    BufferSize = UTF8Size * 2
    BufferUNI = String$(BufferSize, vbNullChar)
    
    LenUNI = MultiByteToWideChar(CP_UTF8, 0&, bUTF8(0), UTF8Size, StrPtr( _
        BufferUNI), BufferSize)
        
    UTF8ToUnicode = Left$(BufferUNI, LenUNI)
    
End Function

Public Function UnicodeToUTF8(ByVal strUnicode As String) As String

    Dim LenUNI          As Long
    Dim BufferSize      As Long
    Dim LenUTF8         As Long
    Dim bUTF8()         As Byte
    
    LenUNI = Len(strUnicode)
    
    If LenUNI = 0 Then Exit Function
    
    BufferSize = LenUNI * 3 + 1
    
    ReDim bUTF8(BufferSize - 1)
    
    LenUTF8 = WideCharToMultiByte(CP_UTF8, 0&, StrPtr(strUnicode), LenUNI, _
        bUTF8(0), BufferSize, vbNullString, 0&)
        
    ReDim Preserve bUTF8(LenUTF8 - 1)
        
    UnicodeToUTF8 = StrConv(bUTF8, vbUnicode)
        
End Function

Public Function DecodeUTF8(ByVal sUTF8 As String) As String

    Dim strRet As String
    
    strRet = Replace$(sUTF8, "\" & ChrW$(34) & "\" & ChrW$(34), ChrW$(34))
    strRet = Replace$(strRet, "\" & ChrW$(34), ChrW$(34))
    strRet = Replace$(strRet, "\u0026", "&")
    strRet = Replace$(strRet, "\u003c", "<")
    strRet = Replace$(strRet, "\u003d", "=")
    strRet = Replace$(strRet, "\u003e", ">")
    strRet = Replace$(strRet, "\\.", "\")
    strRet = Replace$(strRet, "/.", "/")
    strRet = Replace$(strRet, "* *", "*")
    strRet = Replace$(strRet, "§ §", "§")
    strRet = Replace$(strRet, "%.", "%")
    strRet = Replace$(strRet, "}}", "}")
    strRet = Replace$(strRet, "- -", "-")
    strRet = Replace$(strRet, ";;", ";")
    strRet = Replace$(strRet, "::", ":")
    strRet = Replace$(strRet, "\r\n", vbNewLine)
    
    DecodeUTF8 = strRet
    
End Function

Public Function URLEncode(ByVal sURL As String) As String

    Const SAFECHARS = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz.,-_" & vbNullChar
        
    Dim Ret As Long
    Dim Ch As String
    Dim i As Long
    Dim sHex As String
    
    sURL = Replace$(sURL, "%", Chr$(0))
    
    URLEncode = sURL
    
    For i = 1 To Len(sURL)
    
        Ch = Mid$(sURL, i, 1)
        
        Ret = InStr(SAFECHARS, Ch)
        
        If Ret = 0 Then
        
            sHex = Hex$(Asc(Ch))
            
            URLEncode = Replace$(URLEncode, Ch, "%" & IIf(Len(sHex) = 1, _
                "0", "") & sHex)
                
        End If
        
    Next
    
    URLEncode = Replace$(URLEncode, Chr$(0), "%25")
    
End Function

Public Sub SetTbText(ByVal hTbWnd As Long, ByVal sText As String)

    If hTbWnd <> 0& Then
    
        Call SendMessage(hTbWnd, WM_SETTEXT, 0&, ByVal StrPtr(sText))
        
    End If
    
End Sub

Public Function GetTbText(ByVal hTbWnd As Long) As String

    Dim lngTextLen As Long
    Dim strText As String
    
    If hTbWnd <> 0& Then
    
        lngTextLen = SendMessage(hTbWnd, WM_GETTEXTLENGTH, 0&, ByVal 0&)
        
        If lngTextLen > 0& Then
        
            strText = String$(lngTextLen, vbNullChar)
            
            lngTextLen = SendMessage(hTbWnd, WM_GETTEXT, lngTextLen + 1, _
                ByVal StrPtr(strText))
                
        End If
        
        GetTbText = strText
        
    End If
    
End Function

Public Sub MoveTb(ByVal hTbWnd As Long, ByVal x As Long, ByVal y As Long, ByVal _
    Width As Long, ByVal Height As Long)

    If hTbWnd <> 0& Then

        Call MoveWindow(hTbWnd, x, y, Width, Height, API_TRUE)

    End If

End Sub

Public Sub PutFocus(ByVal hwnd As Long)

    If hwnd <> 0 Then
    
        Call Focus(hwnd)
        
    End If
    
End Sub

Public Function WinProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As _
    Long, ByVal lParam As Long) As Long

    Select Case uMsg

    Case WM_CTLCOLOREDIT
        WinProc = API_TRUE

    Case WM_GETMINMAXINFO

        Dim tMINMAXINFO As MINMAXINFO

        Call RtlMoveMemory(tMINMAXINFO, lParam, Len(tMINMAXINFO))

        With tMINMAXINFO

            .ptMaxPosition.x = 0
            .ptMaxPosition.y = 0
            .ptMaxSize.x = Screen.Width / Screen.TwipsPerPixelX
            .ptMaxSize.y = Screen.Height / Screen.TwipsPerPixelY
            .ptMinTrackSize.x = m_tSIZEPAR.xMin
            .ptMinTrackSize.y = m_tSIZEPAR.yMin
            .ptMaxTrackSize.x = m_tSIZEPAR.xMax
            .ptMaxTrackSize.y = m_tSIZEPAR.yMax

        End With

        Call RtlMoveMemory(ByVal lParam, tMINMAXINFO, Len(tMINMAXINFO))

        WinProc = DefWindowProc(hwnd, uMsg, wParam, lParam)

    Case Else
        WinProc = CallWindowProc(m_WinProc, hwnd, uMsg, wParam, lParam)

    End Select

End Function
